VERSION 5.00
Object = "{64FF2CE3-6588-11D5-86E3-40354FC11003}#11.0#0"; "rzTermin3.ocx"
Begin VB.Form frmDemoContainer 
   Caption         =   "Form1"
   ClientHeight    =   8400
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   11400
   LinkTopic       =   "Form1"
   ScaleHeight     =   8400
   ScaleWidth      =   11400
   StartUpPosition =   3  'Windows-Standard
   Begin VB.TextBox txtTipp 
      BackColor       =   &H00C0FFFF&
      BeginProperty Font 
         Name            =   "Tahoma"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   1035
      Left            =   60
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      TabIndex        =   1
      Top             =   60
      Width           =   11295
   End
   Begin rzTermin3.rzTermin rzTermin1 
      Height          =   6615
      Left            =   60
      TabIndex        =   0
      Top             =   1260
      Width           =   11295
      _ExtentX        =   19923
      _ExtentY        =   11668
      BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
   End
   Begin VB.Label lblStatus 
      BorderStyle     =   1  'Fest Einfach
      BeginProperty Font 
         Name            =   "Tahoma"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   315
      Left            =   60
      TabIndex        =   2
      Top             =   7980
      Width           =   11295
   End
End
Attribute VB_Name = "frmDemoContainer"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit


'######################################################################
'
' Beispiel-Projekt fr ActiveX-Komponente Terminkalender(rzTermin3.ocx)
' Version 3.0.1 vom 28.07.01
' Copyright Mathias Rzepus
'######################################################################

'Verweis auf DAO3.6-Bibliothek notwendig !!

Dim ws  As DAO.Workspace
Dim db  As DAO.Database

Private Sub Form_Load()
Dim sql         As String
Dim strPfad     As String
    strPfad = App.Path & "\termine.mdb"
    If Dir(strPfad) = "" Then
        MsgBox "Der Datenbankpfad in Form_Load mu erst angepat werden!", vbCritical
        txtTipp.Text = "Passen Sie erst den Pfad fr die Datenbank an! (Variable strPfad)"
        Exit Sub
    End If
    Set ws = DAO.CreateWorkspace("myWS", "Admin", "")
    Set db = ws.OpenDatabase(strPfad)
    
    With rzTermin1
        'notwendige Eigenschaften:
        Set .Workspace = ws        'bergabe des Workspace der "Termindatenbank" an das Control
        Set .Database = db         'bergabe der "Termindatenbank" an das Control
            
            'Quelldaten "Person"
        .DataSourcePerson = "tblKunde"      'Tabelle die verfgbare Personen enthlt
        .FieldSourcePersonID = "KundeID"    'Eindeutiger Schlssel der Person in DataSourcePerson
        .FieldSourcePerson = "Kunde"        'Name der Person in DataSourcePerson
            
            'Quelldaten "Termin"
        .DataSourceDates = "qryTermin"  'Abfrage die Termine und Namen der Personen bereitstellt
        .FieldDatesDateID = "TerminID"  'Eindeutiger Schlssel des Termins in DataSourceDates
        .FieldDatesDate = "Datum"       'Datum-Feld in DataSourceDates
        .FieldDatesPerson = "Kunde"     'Personen-Feld in DataSourceDates
       
        .Header = "Kunde"          'Spaltenberschrift in der Zoom-Ansicht "Termine des Tages"
        
        'Optional zu verndernde Eigenschaften:
        .AllowChangeView = True     'Wechsel zwischen Wochen-/Monatsansicht erlauben
        .AllowEdit = True           'Hinzufgen/Bearbeiten von Terminen erlauben
        .AllowPrint = True          'Druckfunktion erlauben
        .AllowScroll = True         'Vor-/Zurck-Blttern im Kalender erlauben
        .BackColor = &HFFFFFF       'Farbe des Kalenders
        .BackColorFixed = &HC0C0C0  'Zeile mit Wochentagen (Mo,Di,...)
        .BackcolorPast = &HDCDCDC   'Tage die in der Vergangenheit liegen
        .BackColorSel = &HC0FFFF    'Selektierte Tage (ohne weitere Funktion)
        .PublicHoliday = True       'Feiertage anzeigen
        .View = rzMonat             'Monatsansicht (Woche= rzWoche)
        .DateValue = "01.05.2001"   'Monat der die Beispieltermine enthlt als Starteinstellung setzen
        .Footnote = "Hier kann Ihr Text stehen z.B. das Druckdatum: " & Date   'Funote im Ausdruck
        Set .Font = Me.Font         'Schriftart (VB'ler knnen Font-Objekt bergeben...
        '.FontName = "Arial"         '...(Access'ler knnen Fontname + Fontsize bergeben)
        '.FontSize = 8
        'Refresh ntig nach den Optional- und Datenbank-Eigenschaften sowie nach
        'Grennderung whrend der Laufzeit(Resize)
        .Refresh
    End With
    Me.txtTipp = "Tipp:" & vbCrLf & _
            "1.) Doppelklicken Sie auf einen Tag um einen Termin einzutragen" & vbCrLf & _
            "2.) Probieren Sie auch das Kontextmen (rechte Maustaste)" & vbCrLf & _
            "3.) Passen nicht alle Termine untereinander, erscheint im entsprechenden Feld ein Pfeil. Ein Klick hierauf ffnet die ""Zoom-Ansicht"""
End Sub


Private Sub Form_Resize()
'    rzTermin1.Width = Me.Width * 0.95
'    Wenn die Gre des Controls gendert wird, ist eine Refresh notwendig:
'    rzTermin1.Refresh
End Sub

Private Sub rzTermin1_Click(ByVal CurDay As Date)
    lblStatus.Caption = "Sie haben auf den " & CurDay & " geklickt!"
End Sub

Private Sub rzTermin1_DateChange(ByVal DateID As Long, ByVal DateOld As Date, ByVal DateNew As Date, ByRef bCancel As Boolean)
Dim sql As String, sqlTerminNeu As String
    sqlTerminNeu = Month(DateNew) & "/" & Day(DateNew) & "/" & Year(DateNew) & " " & Format(DateNew, "hh:mm:ss")
    sql = "UPDATE tblTermin SET tblTermin.Datum = #" & sqlTerminNeu & "#" & _
        " WHERE (((tblTermin.TerminID)=" & DateID & "))"
    db.Execute sql
End Sub

Private Sub rzTermin1_DateDel(ByVal DateID As Long, ByVal DateTime As Date, ByVal Person As String, ByRef bCancel As Boolean)
Dim sql As String ', sqlTermin As String, quote As String
    If MsgBox("Termin lschen ?", vbQuestion + vbYesNoCancel) = vbYes Then
        sql = "DELETE *.* FROM tblTermin WHERE (((tblTermin.TerminID)=" & DateID & "))"
        db.Execute sql
    Else
       bCancel = True
    End If
End Sub


Private Sub rzTermin1_DateNew(ByVal DateTime As Date, ByVal PersonID As Long, ByVal Person As String, ByRef bCancel As Boolean)
Dim rs As DAO.Recordset
    If DateTime < Date Then
        If MsgBox("Achtung! Datum des Termins liegt in der Vergangenheit. Trotzdem eintragen?", vbQuestion + vbYesNoCancel) <> vbYes Then
            bCancel = True
            Exit Sub
        End If
    End If
   
    If PersonID = -1 Then 'erst neue Person in Datenbank aufnehmen
        If MsgBox("<" & Person & "> bernehmen und Termin speichern ?", vbQuestion + vbYesNoCancel) = vbYes Then
            Set rs = db.OpenRecordset("tblKunde", dbOpenTable)
            rs.AddNew
            rs![Kunde] = Person
            If rs.Updatable Then
                rs.Update
                rs.MoveLast
                PersonID = rs![KundeID]
            Else
                MsgBox "Person konnte nicht angelegt werden !", vbCritical
                Exit Sub
            End If
            rs.Close
            'Termin fr neu aufgenommene Person speichern
            Set rs = db.OpenRecordset("tblTermin", dbOpenTable)
            rs.AddNew
            rs![Kunde_ID] = PersonID
            rs![Datum] = DateTime
            If rs.Updatable Then
                rs.Update
            Else
                MsgBox "Termin konnte nicht angelegt werden !", vbCritical
            End If
            rs.Close
        Else
            bCancel = True
        End If
    Else ' PersonID <> -1
        Set rs = db.OpenRecordset("tblTermin", dbOpenTable)
        rs.AddNew
        rs![Kunde_ID] = PersonID
        rs![Datum] = DateTime
        If rs.Updatable Then
            rs.Update
        Else
            MsgBox "Termin konnte nicht angelegt werden !", vbCritical
        End If
        rs.Close
    End If
End Sub

Private Sub rzTermin1_DblClick(ByVal CurDay As Date)
    lblStatus.Caption = "Sie haben auf den " & CurDay & " doppelgeklickt!"
End Sub

Private Sub rzTermin1_IncorrectTime(ByVal sTime As String)
    MsgBox "Uhrzeit ist nicht korrekt! <" & sTime & ">", vbExclamation
End Sub


